main:-
	write($Welcome to WUMPUS HUNT$),nl,nl,
	write($Type "helpme." for help.$),nl,
	write($Type "quit." if you wimp out.$),nl,nl,!,
	observe,go.

connected(1,2).connected(2,3).connected(3,4).
connected(4,5).connected(5,6).connected(5,7).
connected(6,19).connected(19,18).connected(18,20).
connected(20,17).connected(17,16).connected(18,16).
connected(15,14).connected(15,16).connected(14,11).
connected(11,10).connected(12,13).connected(11,12).
connected(8,2).connected(8,9).connected(9,11).
connected(8,10).

connected(2,1).connected(3,2).connected(4,3).
connected(5,4).connected(6,5).connected(7,5).
connected(19,6).connected(18,19).connected(20,18).
connected(17,20).connected(16,15).connected(16,17).
connected(16,18).connected(14,15).connected(11,14).
connected(12,11).connected(13,12).connected(10,8).
connected(10,11).connected(9,8).connected(11,9).
connected(2,8).

wumpus(17).
you(2).
arrows(5).
pit(10).
pit(13).
pit(16).
pit(7).
bats(9).
bats(4).

eaten:- 
	you(X),wumpus(X),
	write($It's the WUMPUS! You lose.$),nl,end.
eaten.

fall:- 
	you(X),pit(X),
	write($AA! You fall into a pit. You lose!$),nl,end.
fall.

carried:- 
	you(X),bats(X),get_room(G),check(G,X),
	write($The bats carry you to room #$),write(G),nl,
	retract(you(X)),assert(you(G)),observe.
carried.

check(X,X):- you(X),fail.
check(X,Y):- X \= Y.
check(X,Y):- Y is X + 1, X \= 0, X \= 20.
check(X,Y):- check(X,Y).

get_room(X):-
	X is integer(random * 19) + 1,
	X \= 0,bats(Y), X \= Y.

get_room:- get_room.

stench:-
	you(X),wumpus(Z),connected(X,Y),connected(Y,Z),!,X \= Z,
	write($You smell something funky and it's one room away...$),nl.
stench:-
	you(W),wumpus(Z),connected(W,X),connected(X,Y),
	connected(Y,Z),!,W \= Y,X \= Z,W \= Z,
	write($You smell something funky and it's two rooms away...$),nl.
stench.

sound:-
	you(X),bats(Y),connected(X,Y),
	write($You hear a strange sound, like flapping leather...$),nl.
sound.

draft:-
	you(X),pit(Y),connected(X,Y),!,
	write($A strange draft comes from somewhere...$),nl.
draft.

arrow:-
	arrow(X),wumpus(X),retract(arrow(X)),
	write($You killed the WUMPUS! You win!$),nl,end.
arrow:-
	arrow(X),pit(X),retract(arrow(X)),
	write($An echoing sound comes from room #$),write(X),nl.
arrow:-
	arrow(X),bats(X),retract(arrow(X)),
	write($A squeeking sound comes from room #$),write(X),nl.
arrow.

noarrows:-  arrows(0),write($You have no arrows! You lose.$),nl,end.
noarrows.

go:- eaten,fall,carried,arrow,noarrows,fail.

go:- 
	write($-> $),read(C),
	call(C),movewumpus,go.
go:-
	write($Ready.$),nl,go.

helpme:-
	nl,nl,
	write($Here are the commands you can use:$),nl,
	write($goto(Room). = You move to room #Room$),nl,
	write($shoot(Room). = You shoot an arrow into room #Room.$),nl,
	write($observe. = Observe the surroundings.$),nl,
	write($arrows. = Tells you how many arrows you have left.$),nl,
	write($rooms. = Tells you what rooms you can go into.$),nl,
	write($helpme. = This help section.$),nl,
	write($quit. = Exit the game.$),nl,nl.

goto(X):-
	you(Y),connected(X,Y),write($You go into room #$),write(X),nl,nl,
	retract(you(Y)),assert(you(X)),observe.
goto(X):- write($I can't get to room #$),write(X),nl,nl.

shoot(X):-
	you(Y),connected(X,Y),
	arrows(N), N \= 0, N1 is N - 1, 
	assert(arrow(X)),retract(arrows(N)),
	assert(arrows(N1)),go.
shoot(X):- write($I can't shoot an arrow into room #$),write(X),nl,nl.

quit:- write($Do you wish to exit(yes/no)?$),
	read(X),X=yes,halt.
quit:- observe.

end:- write($Do you wish to exit(yes/no)?$),
	read(X),X=yes,halt.
end:- 
	retract(you(X)),assert(you(2)),
	retract(arrows(Y)),assert(arrows(5)),
	retract(wumpus(Z)),assert(wumpus(17)),
	observe,go.
	
observe:- you(X),write($You are in room #$),write(X),nl,
	carried,arrows,rooms,sound,stench,draft.
observe:- write($That's all.$),nl,nl.

rooms:-
	you(X),connected(X,Y),
	write($You can go to room #$),write(Y),nl,fail.
rooms.

arrows:- 
	arrows(X),write($You have $),
	write(X),write($ arrows left.$),nl.

movewumpus:-
	wumpus(X),!,retract(wumpus(X)),
	connected(X,Y),assert(wumpus(Y)).
movewumpus:- movewumpus.
